; define a procedure that takes:
; s - a combining function that expects two numeric arguments 
; and returns a single numeric value
; f, g - two functions that take a single numeric argument and
; return a single numeric value f(x) or g(x)
; x - the point at which to evaluate f(x) and g(x)
; s-fx-gx returns s(f(x),g(x))

(define identity
  (lambda (x) x))

(define square
  (lambda (x) (* x x)))

(define cube
  (lambda (x) (* x x x)))

(define (s-fx-gx s f g x)
  (s (f x) (g x)))

(s-fx-gx min square cube 2)   ; => (min 4 8) = 4
(s-fx-gx min square cube -2)  ; => (min 4 -8) = -8
(s-fx-gx + square cube 2)     ; => (+ 2 8) = 12
(s-fx-gx - cube square 3)     ; => (- 27 9) = 18

(s-fx-gx
 (lambda (x y) (expt x y))
 identity
 identity
 2)                           ; => (expt 2 2) = 4

(s-fx-gx 
 (lambda (x y) (/ x y))
 cube
 square
 14)                          ; => (/ cube square) = x = 14

(s-fx-gx
 (lambda (x y) (/ (+ x y) 2))
 (lambda (x) (+ x 1))
 (lambda (e) (- e 1))
 128)                         ; => (avg (+ x 1) (- x 1)) => x = 128
